/*
 * Copyright (C) 2007 Loren Merritt <lorenm@u.washington.edu>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include "common.h"

void xlsc_macroblock_analyse( xlsc_t *h )
{
    xlsc_me( h, &h->mb.mv, &h->mb.mvp, 1 );

    if( h->param.mb_decision )
    {
        h->mb.intra = 1;
        int icost = xlsc_rd_cost ( h );
        h->mb.intra = 0;
        int pcost = xlsc_rd_cost ( h );
        h->mb.intra = icost < pcost;
    }
    else
        h->mb.intra = 0;
}
