/*
 * Copyright (C) 2009 Loren Merritt <lorenm@u.washington.edu>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include "common.h"

// Compile another copy of the bitstream functions. This one doesn't actually
// write a bitstream, but just updates the cabrc contexts.

#define xlsc_macroblock_write xlsc_macroblock_rac_update
#define put_rac(c,p,b) transition_rac(c,p,b)
#define put_rac_bypass(c,b)
#define RDO_SKIP_BS

#include "write.c"
